/* +++Date last modified: 05-Jul-1997 */

/*
+----------------------------------------------------+
|               Thunderbird Software                 |
+----------------------------------------------------+
| Filespec  :  Queue.c                               |
| Date      :  September 29, 1994                    |
| Time      :  10:16AM                               |
| Revision  :  1.0                                   |
+----------------------------------------------------+
| Programmer:  Scott Andrews                         |
| Address   :  5358 Summit RD SW                     |
| City/State:  Pataskala, Ohio                       |
| Zip       :  43062                                 |
+----------------------------------------------------+
| Released to the Public Domain                      |
+----------------------------------------------------+
*/

#include <stdlib.h>
#include "queue.h"

QUEUE *QueueAlloc(int size)
{  QUEUE *retval;
  
   retval = (QUEUE *)malloc(sizeof(QUEUE) + (size_t)size);
   if ((QUEUE *) 0 != retval)
   {  
      retval->size = size;
      retval->head = 0;
      retval->tail = 0;
      retval->avail = size;
      retval->buffer = ((char *)retval) + sizeof(QUEUE);
   }
   return retval;
}

int QueuePut(QUEUE *buffer, char data)
{  int retval = -1;

   if ( 0 != buffer->avail)
   {  
      *(buffer->buffer + buffer->head) = data;
      buffer->head += 1;
      if (buffer->head == buffer->size)
         buffer->head = 0;
      buffer->avail -= 1;
      retval = buffer->avail;
   }
   return retval;
}

int QueueGet(QUEUE *buffer)
{  int retval = -1;

   if (buffer->avail != buffer->size)
   {  
      retval = *(buffer->buffer + buffer->tail);
      buffer->tail += 1;
      if (buffer->tail == buffer->size)
         buffer->tail = 0;
      buffer->avail += 1;
   }
   return retval;
}
