#include <stdio.h>
#include <time.h>
#include "uip.h"
#include "rs232dev.h"
#include "httpd.h"

void main(void)
{
   u8_t i;
   u16_t start, current;
  
   puts("Initialising uIP TCP/IP stack");
   rs232dev_init();
   uip_init();
   httpd_init();
   puts("uIP TCP/IP stack and web server running");
   puts("Press any key to stop.");
   start = clock();
   while (!kbhit())
   {
      uip_len = rs232dev_poll();
      if (uip_len > 0)
      {
	 uip_process(UIP_DATA);
	 if (uip_len > 0)
	 {
	    rs232dev_send();
	 }
      }
      current = clock();
      if ((current - start) >= (u16_t)CLK_TCK)
      {
	 for (i = 0; i < UIP_CONNS; ++i)
	 {
	    uip_periodic(i);
	    if (uip_len > 0)
	    {
	       rs232dev_send();
	    }
	 }
	 start = current;
      }
   }
   rs232dev_close();
   getchar();
   puts("TCP/IP stack and web server stopped.");
}
