/* +++Date last modified: 05-Jul-1997 */

/*
+----------------------------------------------------+
|               Thunderbird Software                 |
+----------------------------------------------------+
| Filespec  :  Serial.c                              |
| Date      :  October 24, 1991                      |
| Time      :  15:03                                 |
| Revision  :  1.1                                   |
| Update    : August 29, 1994                        |
| Update    : March 12, 1995 by Bob Stout            |
+----------------------------------------------------+
| Programmer:  Scott Andrews                         |
| Address   :  5358 Summit RD SW                     |
| City/State:  Pataskala, Ohio                       |
| Zip       :  43062                                 |
+----------------------------------------------------+
| Released to the Public Domain                      |
+----------------------------------------------------+
| Modified for Portfolio and add some constants      |
| Michael Bernstein                                  |
+----------------------------------------------------+
*/

#ifndef SERIAL__H
#define SERIAL__H

#define  NONE            0             /* Handshake param none     */
#define  HDW             1             /* Handshake param hardware */
#define  XON             2             /* Handshake param software */

#define COM_PORT_1 1
#define COM_PORT_2 2
#define COM_PORT_3 3
#define COM_PORT_4 4

#define COM_BAUD_300       "300"
#define COM_BAUD_1200     "1200"
#define COM_BAUD_2400     "2400"
#define COM_BAUD_4800     "4800"
#define COM_BAUD_9600     "9600"
#define COM_BAUD_19200   "19200"
#define COM_BAUD_38400   "38400"
#define COM_BAUD_57600   "57600"
#define COM_BAUD_115200 "115200"

#define COM_PARITY_ODD   'O'           /* odd parity   */
#define COM_PARITY_EVEN  'E'           /* even parity  */
#define COM_PARITY_STICK 'S'           /* stick parity */
#define COM_PARITY_NO    'N'           /* no parity    */

#define COM_DATABITS_5 '5'
#define COM_DATABITS_6 '6'
#define COM_DATABITS_7 '7'
#define COM_DATABITS_8 '8'
      
#define COM_STOPBITS_2 '2'
#define COM_STOPBITS_1 '1'

typedef struct                         /* Save existing comm params     */
{  int int_enable;                     /* old interrupt enable reg value*/
   int line;                           /*  "  line control      "    "  */
   int modem;                          /* old modem control     "    "  */
   int baud_lsb;                       /* old baud rate divisor LSD     */
   int baud_msb;                       /*  "   "    "      "    MSD     */
   int int_cntrl;                      /* old PIC interrupt reg value   */
} OLD_COMM_PARAMS;
extern OLD_COMM_PARAMS old_comm_params;

typedef struct
{  
   int line;                           /* Uart line status reg.         */
   int modem;                          /* Uart mode status reg.         */
   int intrupt;                        /* Uart interrupt reg.           */
   int handshake;                      /* Handshake status              */
} COMM_STATUS;                         /* status, updated, handler      */
extern COMM_STATUS comm_status;

int   OpenComPort( void );              /* setup comm for usage        */
void  InitComPort( char Baud[], char Databits, char Parity, char Stop );
void  CloseComPort( void );             /* Restore comm port           */
int   ComRecChar( void );               /* Fetch character from rcv buf*/
int   ComSendChar( char character );    /* Put char into xmit buffer   */
int   ComSendString( char *string );
int   ComStatus( void );                /* Fetch comm status           */

#endif /* SERIAL__H */
